LeetCode-TwoSum(easy)-for Java,C++,Python

题目

Given an array of integers, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.

You may assume that each input would have exactly one solution.

Input: numbers={2, 7, 11, 15}, target=9
Output: index1=1, index2=2
  • Java
import java.util.HashMap;
import java.util.Map;

public class TwoSum {
    /**
     * Given an array of integers, return indices of the two numbers such that they add up to a specific target.

        You may assume that each input would have exactly one solution.

        Example: 
        Given nums = [2, 7, 11, 15], target = 9,

        Because nums[0] + nums[1] = 2 + 7 = 9, 
        return [0, 1].
     */

    public static void main(String[] args) {
        TwoSum t = new TwoSum();
        int[] numbers = {3,2,4};
        int target = 6;
        int[] res = t.twoSum(numbers, target);
        for(int i = 0 ; i < res.length; i++) {
            System.out.print(i == res.length - 1?res[i]:res[i]+",");
        }
    }
    
    public int[] twoSum(int[] numbers,int target) {
        Map map = new HashMap();
        for(int i = 0; i < numbers.length; i++) {// put all numbers to the map
            map.put(numbers[i], i);
        }
        
        for(int i = 0 ; i < numbers.length; i++) {
            int newtarget = target - numbers[i];
            if(map.containsKey(newtarget) && i != map.get(newtarget)) {
                return new int[] {i+1,map.get(newtarget) + 1};
            }
        }
        
        return null;
    }
}

运行结果:


LeetCode-TwoSum(easy)-for Java,C++,Python_第1张图片
java运行结果
  • C++
#include
#include
using namespace std;

/**
 * Given an array of integers, return indices of the two numbers such that they add up to a specific target.

    You may assume that each input would have exactly one solution.

    Example: 
    Given nums = [2, 7, 11, 15], target = 9,

    Because nums[0] + nums[1] = 2 + 7 = 9, 
    return [0, 1].
 */

class Solution{
public:
    vector TwoSum(vector& numbers,int target)
    {
        vector result;
        int sum = 0;
        for(int i = 0 ; i < numbers.size(); i++)
        {
            for(int j = i + 1 ; j < numbers.size() ; j++)
            {
                sum = numbers[i] + numbers[j];
                if(sum == target)
                {
                    result.push_back(i+1);
                    result.push_back(j+1);
                    break;
                }
            }
        }

        return result;
    }
};

int main(void)
{
    vector numbers;
    numbers.push_back(2);
    numbers.push_back(7);
    numbers.push_back(11);
    numbers.push_back(15);
    int target = 18;
    vector result;
    Solution res;
    result = res.TwoSum(numbers,target);
    for(int i = 0 ; i < result.size(); i++)
    {
        if(i != result.size() - 1)
            cout<

运行结果:


LeetCode-TwoSum(easy)-for Java,C++,Python_第2张图片
C++运行结果
  • Python

    class Solution(object):
    """
    :type nums:List[int]
    :type target:int
    :rtype: List[int]
    """
        def twoSum(self,nums,target):
            num_to_index = {}   # key is number,value is index in nums
            for i,num in enumerate(nums):
                if target - num in num_to_index:
                    return [i,num_to_index[target-num]]
    
                num_to_index[num] = i
            return [] # no sum
    
    
    if __name__ == '__main__':  
    TwoSum = Solution()                                  
    nums = [2,7,11,15,1,3,53,245]
    print TwoSum.twoSum(nums,56)
    
    class Solution(object):
    """
    :type nums:List[int]
    :type target:int
    :rtype: List[int]
    """
        def twoSum(self,nums,target):
            for i,num in enumerate(nums):
                if target - num in nums and nums[i] != target - num:
                    return [i,nums.index(target - num)]
            return [] # no sum
    
    
    if __name__ == '__main__':  
        TwoSum = Solution()                                  
        nums = [2,7,11,15,1,3,53,245]
        print TwoSum.twoSum(nums,56)
    
    
    class Solution:
        def twoSum(self,nums,target):
            size = len(nums)
            for i in range(size):
                for j in range(i+1,size):
                    if(nums[i] + nums[j] == target):
                        return i,j
            return 0,0
    
    if __name__ == "__main__":
        nums = [2,7,11,15,1,3,53,245]
        TwoSum = Solution()
        print TwoSum.twoSum(nums,56)
    

运行结果:


LeetCode-TwoSum(easy)-for Java,C++,Python_第3张图片
Python运行结果

总结:因为题中说明了只有一对答案,因此不需要考虑重复的情况。三种语言实现的基本思路都是相同的。

  1. 先确定第一个数,然后用目标数减去这个数,判断减去的结果是否在原数组中,如果在,就返回他们的索引。
  2. 先确定一个数,然后在这个数之后的数中选一个,如果这连个数相加为目标数,则返回他们的索引。

你可能感兴趣的:(LeetCode-TwoSum(easy)-for Java,C++,Python)